# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetHostResult',
    'AwaitableGetHostResult',
    'get_host',
    'get_host_output',
]

@pulumi.output_type
class GetHostResult:
    """
    A collection of values returned by getHost.
    """
    def __init__(__self__, id=None, name=None, tags=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if tags and not isinstance(tags, list):
            raise TypeError("Expected argument 'tags' to be a list")
        pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def tags(self) -> Optional[Sequence[str]]:
        """
        Required tags of the host to find
        """
        return pulumi.get(self, "tags")


class AwaitableGetHostResult(GetHostResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetHostResult(
            id=self.id,
            name=self.name,
            tags=self.tags)


def get_host(name: Optional[str] = None,
             tags: Optional[Sequence[str]] = None,
             opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetHostResult:
    """
    The host data source allows the host ID to be retrieved by its name and optionally tags / tag-value pairs.

    - `name` queries for all hosts with the specified name
    - `tags` (optional) refers to the tags that need to be present for the host (inclusive)

    If multiple hosts match the given criteria, the first result will be retrieved.

    ## Example Usage

    ```python
    import pulumi
    import lbrlabs_pulumi_dynatrace as dynatrace
    import pulumi_dynatrace as dynatrace

    test = dynatrace.get_host(name="Example",
        tags=[
            "TerraformKeyTest",
            "TerraformKeyValueTest=TestValue",
        ])
    _name_ = dynatrace.ManagementZone("#name#", entity_selector_based_rules=[dynatrace.ManagementZoneEntitySelectorBasedRuleArgs(
        enabled=True,
        selector=f"type(\\"host\\"),entityId(\\"{test.id}\\")",
    )])
    ```


    :param Sequence[str] tags: Required tags of the host to find
    """
    __args__ = dict()
    __args__['name'] = name
    __args__['tags'] = tags
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('dynatrace:index/getHost:getHost', __args__, opts=opts, typ=GetHostResult).value

    return AwaitableGetHostResult(
        id=__ret__.id,
        name=__ret__.name,
        tags=__ret__.tags)


@_utilities.lift_output_func(get_host)
def get_host_output(name: Optional[pulumi.Input[str]] = None,
                    tags: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                    opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetHostResult]:
    """
    The host data source allows the host ID to be retrieved by its name and optionally tags / tag-value pairs.

    - `name` queries for all hosts with the specified name
    - `tags` (optional) refers to the tags that need to be present for the host (inclusive)

    If multiple hosts match the given criteria, the first result will be retrieved.

    ## Example Usage

    ```python
    import pulumi
    import lbrlabs_pulumi_dynatrace as dynatrace
    import pulumi_dynatrace as dynatrace

    test = dynatrace.get_host(name="Example",
        tags=[
            "TerraformKeyTest",
            "TerraformKeyValueTest=TestValue",
        ])
    _name_ = dynatrace.ManagementZone("#name#", entity_selector_based_rules=[dynatrace.ManagementZoneEntitySelectorBasedRuleArgs(
        enabled=True,
        selector=f"type(\\"host\\"),entityId(\\"{test.id}\\")",
    )])
    ```


    :param Sequence[str] tags: Required tags of the host to find
    """
    ...
