# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetRequestNamingResult',
    'AwaitableGetRequestNamingResult',
    'get_request_naming',
    'get_request_naming_output',
]

@pulumi.output_type
class GetRequestNamingResult:
    """
    A collection of values returned by getRequestNaming.
    """
    def __init__(__self__, id=None, name=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")


class AwaitableGetRequestNamingResult(GetRequestNamingResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetRequestNamingResult(
            id=self.id,
            name=self.name)


def get_request_naming(name: Optional[str] = None,
                       opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetRequestNamingResult:
    """
    The `RequestNaming` data source allows the request naming rule ID to be retrieved by its name.

    - `name` (String) - The name to be assigned to matching requests.

    If multiple services match the given criteria, the first result will be retrieved.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_dynatrace as dynatrace

    example = dynatrace.get_request_naming(name="Terraform Example")
    pulumi.export("id", example.id)
    ```
    """
    __args__ = dict()
    __args__['name'] = name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('dynatrace:index/getRequestNaming:getRequestNaming', __args__, opts=opts, typ=GetRequestNamingResult).value

    return AwaitableGetRequestNamingResult(
        id=__ret__.id,
        name=__ret__.name)


@_utilities.lift_output_func(get_request_naming)
def get_request_naming_output(name: Optional[pulumi.Input[str]] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetRequestNamingResult]:
    """
    The `RequestNaming` data source allows the request naming rule ID to be retrieved by its name.

    - `name` (String) - The name to be assigned to matching requests.

    If multiple services match the given criteria, the first result will be retrieved.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_dynatrace as dynatrace

    example = dynatrace.get_request_naming(name="Terraform Example")
    pulumi.export("id", example.id)
    ```
    """
    ...
