# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['MetricQueryArgs', 'MetricQuery']

@pulumi.input_type
class MetricQueryArgs:
    def __init__(__self__, *,
                 metric_id: pulumi.Input[str],
                 metric_selector: pulumi.Input[str]):
        """
        The set of arguments for constructing a MetricQuery resource.
        :param pulumi.Input[str] metric_id: The scope of this setting (metric)
        :param pulumi.Input[str] metric_selector: Query
        """
        pulumi.set(__self__, "metric_id", metric_id)
        pulumi.set(__self__, "metric_selector", metric_selector)

    @property
    @pulumi.getter(name="metricId")
    def metric_id(self) -> pulumi.Input[str]:
        """
        The scope of this setting (metric)
        """
        return pulumi.get(self, "metric_id")

    @metric_id.setter
    def metric_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "metric_id", value)

    @property
    @pulumi.getter(name="metricSelector")
    def metric_selector(self) -> pulumi.Input[str]:
        """
        Query
        """
        return pulumi.get(self, "metric_selector")

    @metric_selector.setter
    def metric_selector(self, value: pulumi.Input[str]):
        pulumi.set(self, "metric_selector", value)


@pulumi.input_type
class _MetricQueryState:
    def __init__(__self__, *,
                 metric_id: Optional[pulumi.Input[str]] = None,
                 metric_selector: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering MetricQuery resources.
        :param pulumi.Input[str] metric_id: The scope of this setting (metric)
        :param pulumi.Input[str] metric_selector: Query
        """
        if metric_id is not None:
            pulumi.set(__self__, "metric_id", metric_id)
        if metric_selector is not None:
            pulumi.set(__self__, "metric_selector", metric_selector)

    @property
    @pulumi.getter(name="metricId")
    def metric_id(self) -> Optional[pulumi.Input[str]]:
        """
        The scope of this setting (metric)
        """
        return pulumi.get(self, "metric_id")

    @metric_id.setter
    def metric_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "metric_id", value)

    @property
    @pulumi.getter(name="metricSelector")
    def metric_selector(self) -> Optional[pulumi.Input[str]]:
        """
        Query
        """
        return pulumi.get(self, "metric_selector")

    @metric_selector.setter
    def metric_selector(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "metric_selector", value)


class MetricQuery(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 metric_id: Optional[pulumi.Input[str]] = None,
                 metric_selector: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Create a MetricQuery resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] metric_id: The scope of this setting (metric)
        :param pulumi.Input[str] metric_selector: Query
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: MetricQueryArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a MetricQuery resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param MetricQueryArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(MetricQueryArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 metric_id: Optional[pulumi.Input[str]] = None,
                 metric_selector: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = MetricQueryArgs.__new__(MetricQueryArgs)

            if metric_id is None and not opts.urn:
                raise TypeError("Missing required property 'metric_id'")
            __props__.__dict__["metric_id"] = metric_id
            if metric_selector is None and not opts.urn:
                raise TypeError("Missing required property 'metric_selector'")
            __props__.__dict__["metric_selector"] = metric_selector
        super(MetricQuery, __self__).__init__(
            'dynatrace:index/metricQuery:MetricQuery',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            metric_id: Optional[pulumi.Input[str]] = None,
            metric_selector: Optional[pulumi.Input[str]] = None) -> 'MetricQuery':
        """
        Get an existing MetricQuery resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] metric_id: The scope of this setting (metric)
        :param pulumi.Input[str] metric_selector: Query
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _MetricQueryState.__new__(_MetricQueryState)

        __props__.__dict__["metric_id"] = metric_id
        __props__.__dict__["metric_selector"] = metric_selector
        return MetricQuery(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="metricId")
    def metric_id(self) -> pulumi.Output[str]:
        """
        The scope of this setting (metric)
        """
        return pulumi.get(self, "metric_id")

    @property
    @pulumi.getter(name="metricSelector")
    def metric_selector(self) -> pulumi.Output[str]:
        """
        Query
        """
        return pulumi.get(self, "metric_selector")

