# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['MonitoredTechnologiesGoArgs', 'MonitoredTechnologiesGo']

@pulumi.input_type
class MonitoredTechnologiesGoArgs:
    def __init__(__self__, *,
                 enabled: pulumi.Input[bool],
                 enabled_go_static_monitoring: Optional[pulumi.Input[bool]] = None,
                 host_id: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a MonitoredTechnologiesGo resource.
        :param pulumi.Input[bool] enabled: This setting is enabled (`true`) or disabled (`false`)
        :param pulumi.Input[bool] enabled_go_static_monitoring: Learn more about the [known limitations for Go static monitoring](https://www.dynatrace.com/support/help/technology-support/application-software/go/support/go-known-limitations#limitations)
        :param pulumi.Input[str] host_id: The scope of this settings. If the settings should cover the whole environment, just don't specify any scope.
        """
        pulumi.set(__self__, "enabled", enabled)
        if enabled_go_static_monitoring is not None:
            pulumi.set(__self__, "enabled_go_static_monitoring", enabled_go_static_monitoring)
        if host_id is not None:
            pulumi.set(__self__, "host_id", host_id)

    @property
    @pulumi.getter
    def enabled(self) -> pulumi.Input[bool]:
        """
        This setting is enabled (`true`) or disabled (`false`)
        """
        return pulumi.get(self, "enabled")

    @enabled.setter
    def enabled(self, value: pulumi.Input[bool]):
        pulumi.set(self, "enabled", value)

    @property
    @pulumi.getter(name="enabledGoStaticMonitoring")
    def enabled_go_static_monitoring(self) -> Optional[pulumi.Input[bool]]:
        """
        Learn more about the [known limitations for Go static monitoring](https://www.dynatrace.com/support/help/technology-support/application-software/go/support/go-known-limitations#limitations)
        """
        return pulumi.get(self, "enabled_go_static_monitoring")

    @enabled_go_static_monitoring.setter
    def enabled_go_static_monitoring(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enabled_go_static_monitoring", value)

    @property
    @pulumi.getter(name="hostId")
    def host_id(self) -> Optional[pulumi.Input[str]]:
        """
        The scope of this settings. If the settings should cover the whole environment, just don't specify any scope.
        """
        return pulumi.get(self, "host_id")

    @host_id.setter
    def host_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "host_id", value)


@pulumi.input_type
class _MonitoredTechnologiesGoState:
    def __init__(__self__, *,
                 enabled: Optional[pulumi.Input[bool]] = None,
                 enabled_go_static_monitoring: Optional[pulumi.Input[bool]] = None,
                 host_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering MonitoredTechnologiesGo resources.
        :param pulumi.Input[bool] enabled: This setting is enabled (`true`) or disabled (`false`)
        :param pulumi.Input[bool] enabled_go_static_monitoring: Learn more about the [known limitations for Go static monitoring](https://www.dynatrace.com/support/help/technology-support/application-software/go/support/go-known-limitations#limitations)
        :param pulumi.Input[str] host_id: The scope of this settings. If the settings should cover the whole environment, just don't specify any scope.
        """
        if enabled is not None:
            pulumi.set(__self__, "enabled", enabled)
        if enabled_go_static_monitoring is not None:
            pulumi.set(__self__, "enabled_go_static_monitoring", enabled_go_static_monitoring)
        if host_id is not None:
            pulumi.set(__self__, "host_id", host_id)

    @property
    @pulumi.getter
    def enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        This setting is enabled (`true`) or disabled (`false`)
        """
        return pulumi.get(self, "enabled")

    @enabled.setter
    def enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enabled", value)

    @property
    @pulumi.getter(name="enabledGoStaticMonitoring")
    def enabled_go_static_monitoring(self) -> Optional[pulumi.Input[bool]]:
        """
        Learn more about the [known limitations for Go static monitoring](https://www.dynatrace.com/support/help/technology-support/application-software/go/support/go-known-limitations#limitations)
        """
        return pulumi.get(self, "enabled_go_static_monitoring")

    @enabled_go_static_monitoring.setter
    def enabled_go_static_monitoring(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enabled_go_static_monitoring", value)

    @property
    @pulumi.getter(name="hostId")
    def host_id(self) -> Optional[pulumi.Input[str]]:
        """
        The scope of this settings. If the settings should cover the whole environment, just don't specify any scope.
        """
        return pulumi.get(self, "host_id")

    @host_id.setter
    def host_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "host_id", value)


class MonitoredTechnologiesGo(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 enabled: Optional[pulumi.Input[bool]] = None,
                 enabled_go_static_monitoring: Optional[pulumi.Input[bool]] = None,
                 host_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Create a MonitoredTechnologiesGo resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] enabled: This setting is enabled (`true`) or disabled (`false`)
        :param pulumi.Input[bool] enabled_go_static_monitoring: Learn more about the [known limitations for Go static monitoring](https://www.dynatrace.com/support/help/technology-support/application-software/go/support/go-known-limitations#limitations)
        :param pulumi.Input[str] host_id: The scope of this settings. If the settings should cover the whole environment, just don't specify any scope.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: MonitoredTechnologiesGoArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a MonitoredTechnologiesGo resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param MonitoredTechnologiesGoArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(MonitoredTechnologiesGoArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 enabled: Optional[pulumi.Input[bool]] = None,
                 enabled_go_static_monitoring: Optional[pulumi.Input[bool]] = None,
                 host_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = MonitoredTechnologiesGoArgs.__new__(MonitoredTechnologiesGoArgs)

            if enabled is None and not opts.urn:
                raise TypeError("Missing required property 'enabled'")
            __props__.__dict__["enabled"] = enabled
            __props__.__dict__["enabled_go_static_monitoring"] = enabled_go_static_monitoring
            __props__.__dict__["host_id"] = host_id
        super(MonitoredTechnologiesGo, __self__).__init__(
            'dynatrace:index/monitoredTechnologiesGo:MonitoredTechnologiesGo',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            enabled: Optional[pulumi.Input[bool]] = None,
            enabled_go_static_monitoring: Optional[pulumi.Input[bool]] = None,
            host_id: Optional[pulumi.Input[str]] = None) -> 'MonitoredTechnologiesGo':
        """
        Get an existing MonitoredTechnologiesGo resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] enabled: This setting is enabled (`true`) or disabled (`false`)
        :param pulumi.Input[bool] enabled_go_static_monitoring: Learn more about the [known limitations for Go static monitoring](https://www.dynatrace.com/support/help/technology-support/application-software/go/support/go-known-limitations#limitations)
        :param pulumi.Input[str] host_id: The scope of this settings. If the settings should cover the whole environment, just don't specify any scope.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _MonitoredTechnologiesGoState.__new__(_MonitoredTechnologiesGoState)

        __props__.__dict__["enabled"] = enabled
        __props__.__dict__["enabled_go_static_monitoring"] = enabled_go_static_monitoring
        __props__.__dict__["host_id"] = host_id
        return MonitoredTechnologiesGo(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def enabled(self) -> pulumi.Output[bool]:
        """
        This setting is enabled (`true`) or disabled (`false`)
        """
        return pulumi.get(self, "enabled")

    @property
    @pulumi.getter(name="enabledGoStaticMonitoring")
    def enabled_go_static_monitoring(self) -> pulumi.Output[Optional[bool]]:
        """
        Learn more about the [known limitations for Go static monitoring](https://www.dynatrace.com/support/help/technology-support/application-software/go/support/go-known-limitations#limitations)
        """
        return pulumi.get(self, "enabled_go_static_monitoring")

    @property
    @pulumi.getter(name="hostId")
    def host_id(self) -> pulumi.Output[Optional[str]]:
        """
        The scope of this settings. If the settings should cover the whole environment, just don't specify any scope.
        """
        return pulumi.get(self, "host_id")

