# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['OwnershipConfigArgs', 'OwnershipConfig']

@pulumi.input_type
class OwnershipConfigArgs:
    def __init__(__self__, *,
                 ownership_identifiers: pulumi.Input['OwnershipConfigOwnershipIdentifiersArgs']):
        """
        The set of arguments for constructing a OwnershipConfig resource.
        :param pulumi.Input['OwnershipConfigOwnershipIdentifiersArgs'] ownership_identifiers: Tags and metadata are key-value pairs. Define keys for tags and metadata that are considered for ownership. If a tag or any metadata starts with a key defined below, the value of the tag or metadata is considered a team identifier.
        """
        pulumi.set(__self__, "ownership_identifiers", ownership_identifiers)

    @property
    @pulumi.getter(name="ownershipIdentifiers")
    def ownership_identifiers(self) -> pulumi.Input['OwnershipConfigOwnershipIdentifiersArgs']:
        """
        Tags and metadata are key-value pairs. Define keys for tags and metadata that are considered for ownership. If a tag or any metadata starts with a key defined below, the value of the tag or metadata is considered a team identifier.
        """
        return pulumi.get(self, "ownership_identifiers")

    @ownership_identifiers.setter
    def ownership_identifiers(self, value: pulumi.Input['OwnershipConfigOwnershipIdentifiersArgs']):
        pulumi.set(self, "ownership_identifiers", value)


@pulumi.input_type
class _OwnershipConfigState:
    def __init__(__self__, *,
                 ownership_identifiers: Optional[pulumi.Input['OwnershipConfigOwnershipIdentifiersArgs']] = None):
        """
        Input properties used for looking up and filtering OwnershipConfig resources.
        :param pulumi.Input['OwnershipConfigOwnershipIdentifiersArgs'] ownership_identifiers: Tags and metadata are key-value pairs. Define keys for tags and metadata that are considered for ownership. If a tag or any metadata starts with a key defined below, the value of the tag or metadata is considered a team identifier.
        """
        if ownership_identifiers is not None:
            pulumi.set(__self__, "ownership_identifiers", ownership_identifiers)

    @property
    @pulumi.getter(name="ownershipIdentifiers")
    def ownership_identifiers(self) -> Optional[pulumi.Input['OwnershipConfigOwnershipIdentifiersArgs']]:
        """
        Tags and metadata are key-value pairs. Define keys for tags and metadata that are considered for ownership. If a tag or any metadata starts with a key defined below, the value of the tag or metadata is considered a team identifier.
        """
        return pulumi.get(self, "ownership_identifiers")

    @ownership_identifiers.setter
    def ownership_identifiers(self, value: Optional[pulumi.Input['OwnershipConfigOwnershipIdentifiersArgs']]):
        pulumi.set(self, "ownership_identifiers", value)


class OwnershipConfig(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 ownership_identifiers: Optional[pulumi.Input[pulumi.InputType['OwnershipConfigOwnershipIdentifiersArgs']]] = None,
                 __props__=None):
        """
        Create a OwnershipConfig resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[pulumi.InputType['OwnershipConfigOwnershipIdentifiersArgs']] ownership_identifiers: Tags and metadata are key-value pairs. Define keys for tags and metadata that are considered for ownership. If a tag or any metadata starts with a key defined below, the value of the tag or metadata is considered a team identifier.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: OwnershipConfigArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a OwnershipConfig resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param OwnershipConfigArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(OwnershipConfigArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 ownership_identifiers: Optional[pulumi.Input[pulumi.InputType['OwnershipConfigOwnershipIdentifiersArgs']]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = OwnershipConfigArgs.__new__(OwnershipConfigArgs)

            if ownership_identifiers is None and not opts.urn:
                raise TypeError("Missing required property 'ownership_identifiers'")
            __props__.__dict__["ownership_identifiers"] = ownership_identifiers
        super(OwnershipConfig, __self__).__init__(
            'dynatrace:index/ownershipConfig:OwnershipConfig',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            ownership_identifiers: Optional[pulumi.Input[pulumi.InputType['OwnershipConfigOwnershipIdentifiersArgs']]] = None) -> 'OwnershipConfig':
        """
        Get an existing OwnershipConfig resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[pulumi.InputType['OwnershipConfigOwnershipIdentifiersArgs']] ownership_identifiers: Tags and metadata are key-value pairs. Define keys for tags and metadata that are considered for ownership. If a tag or any metadata starts with a key defined below, the value of the tag or metadata is considered a team identifier.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _OwnershipConfigState.__new__(_OwnershipConfigState)

        __props__.__dict__["ownership_identifiers"] = ownership_identifiers
        return OwnershipConfig(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="ownershipIdentifiers")
    def ownership_identifiers(self) -> pulumi.Output['outputs.OwnershipConfigOwnershipIdentifiers']:
        """
        Tags and metadata are key-value pairs. Define keys for tags and metadata that are considered for ownership. If a tag or any metadata starts with a key defined below, the value of the tag or metadata is considered a team identifier.
        """
        return pulumi.get(self, "ownership_identifiers")

