# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = [
    'GetAttackAlertingResult',
    'AwaitableGetAttackAlertingResult',
    'get_attack_alerting',
    'get_attack_alerting_output',
]

@pulumi.output_type
class GetAttackAlertingResult:
    """
    A collection of values returned by getAttackAlerting.
    """
    def __init__(__self__, id=None, name=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")


class AwaitableGetAttackAlertingResult(GetAttackAlertingResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetAttackAlertingResult(
            id=self.id,
            name=self.name)


def get_attack_alerting(name: Optional[str] = None,
                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetAttackAlertingResult:
    """
    The `AttackAlerting` data source allows the attack alerting profile ID to be retrieved by its name.

    - `name` (String) - The name of the attack alerting profile

    If multiple services match the given criteria, the first result will be retrieved.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_dynatrace as dynatrace

    example = dynatrace.get_attack_alerting(name="Terraform Example")
    pulumi.export("id", example.id)
    ```
    """
    __args__ = dict()
    __args__['name'] = name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('dynatrace:index/getAttackAlerting:getAttackAlerting', __args__, opts=opts, typ=GetAttackAlertingResult).value

    return AwaitableGetAttackAlertingResult(
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'))
def get_attack_alerting_output(name: Optional[pulumi.Input[str]] = None,
                               opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetAttackAlertingResult]:
    """
    The `AttackAlerting` data source allows the attack alerting profile ID to be retrieved by its name.

    - `name` (String) - The name of the attack alerting profile

    If multiple services match the given criteria, the first result will be retrieved.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_dynatrace as dynatrace

    example = dynatrace.get_attack_alerting(name="Terraform Example")
    pulumi.export("id", example.id)
    ```
    """
    __args__ = dict()
    __args__['name'] = name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('dynatrace:index/getAttackAlerting:getAttackAlerting', __args__, opts=opts, typ=GetAttackAlertingResult)
    return __ret__.apply(lambda __response__: GetAttackAlertingResult(
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name')))
