# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = [
    'GetCalculatedServiceMetricResult',
    'AwaitableGetCalculatedServiceMetricResult',
    'get_calculated_service_metric',
    'get_calculated_service_metric_output',
]

@pulumi.output_type
class GetCalculatedServiceMetricResult:
    """
    A collection of values returned by getCalculatedServiceMetric.
    """
    def __init__(__self__, id=None, name=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")


class AwaitableGetCalculatedServiceMetricResult(GetCalculatedServiceMetricResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetCalculatedServiceMetricResult(
            id=self.id,
            name=self.name)


def get_calculated_service_metric(name: Optional[str] = None,
                                  opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetCalculatedServiceMetricResult:
    """
    The calculated service metric data source allows the metric ID to be retrieved by its name.

    - `name` (String) - The name of the calculated service metric

    ## Example Usage

    ```python
    import pulumi
    import pulumi_dynatrace as dynatrace

    example = dynatrace.get_calculated_service_metric(name="Terraform Example")
    pulumi.export("groups", example.id)
    ```
    """
    __args__ = dict()
    __args__['name'] = name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('dynatrace:index/getCalculatedServiceMetric:getCalculatedServiceMetric', __args__, opts=opts, typ=GetCalculatedServiceMetricResult).value

    return AwaitableGetCalculatedServiceMetricResult(
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'))
def get_calculated_service_metric_output(name: Optional[pulumi.Input[str]] = None,
                                         opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetCalculatedServiceMetricResult]:
    """
    The calculated service metric data source allows the metric ID to be retrieved by its name.

    - `name` (String) - The name of the calculated service metric

    ## Example Usage

    ```python
    import pulumi
    import pulumi_dynatrace as dynatrace

    example = dynatrace.get_calculated_service_metric(name="Terraform Example")
    pulumi.export("groups", example.id)
    ```
    """
    __args__ = dict()
    __args__['name'] = name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('dynatrace:index/getCalculatedServiceMetric:getCalculatedServiceMetric', __args__, opts=opts, typ=GetCalculatedServiceMetricResult)
    return __ret__.apply(lambda __response__: GetCalculatedServiceMetricResult(
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name')))
