# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['MobileAppCrashRateArgs', 'MobileAppCrashRate']

@pulumi.input_type
class MobileAppCrashRateArgs:
    def __init__(__self__, *,
                 crash_rate_increase: pulumi.Input['MobileAppCrashRateCrashRateIncreaseArgs'],
                 application_id: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a MobileAppCrashRate resource.
        :param pulumi.Input['MobileAppCrashRateCrashRateIncreaseArgs'] crash_rate_increase: Crash rate increase
        :param pulumi.Input[str] application_id: The scope of this settings. If the settings should cover the whole environment, just don't specify any scope.
        """
        pulumi.set(__self__, "crash_rate_increase", crash_rate_increase)
        if application_id is not None:
            pulumi.set(__self__, "application_id", application_id)

    @property
    @pulumi.getter(name="crashRateIncrease")
    def crash_rate_increase(self) -> pulumi.Input['MobileAppCrashRateCrashRateIncreaseArgs']:
        """
        Crash rate increase
        """
        return pulumi.get(self, "crash_rate_increase")

    @crash_rate_increase.setter
    def crash_rate_increase(self, value: pulumi.Input['MobileAppCrashRateCrashRateIncreaseArgs']):
        pulumi.set(self, "crash_rate_increase", value)

    @property
    @pulumi.getter(name="applicationId")
    def application_id(self) -> Optional[pulumi.Input[str]]:
        """
        The scope of this settings. If the settings should cover the whole environment, just don't specify any scope.
        """
        return pulumi.get(self, "application_id")

    @application_id.setter
    def application_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "application_id", value)


@pulumi.input_type
class _MobileAppCrashRateState:
    def __init__(__self__, *,
                 application_id: Optional[pulumi.Input[str]] = None,
                 crash_rate_increase: Optional[pulumi.Input['MobileAppCrashRateCrashRateIncreaseArgs']] = None):
        """
        Input properties used for looking up and filtering MobileAppCrashRate resources.
        :param pulumi.Input[str] application_id: The scope of this settings. If the settings should cover the whole environment, just don't specify any scope.
        :param pulumi.Input['MobileAppCrashRateCrashRateIncreaseArgs'] crash_rate_increase: Crash rate increase
        """
        if application_id is not None:
            pulumi.set(__self__, "application_id", application_id)
        if crash_rate_increase is not None:
            pulumi.set(__self__, "crash_rate_increase", crash_rate_increase)

    @property
    @pulumi.getter(name="applicationId")
    def application_id(self) -> Optional[pulumi.Input[str]]:
        """
        The scope of this settings. If the settings should cover the whole environment, just don't specify any scope.
        """
        return pulumi.get(self, "application_id")

    @application_id.setter
    def application_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "application_id", value)

    @property
    @pulumi.getter(name="crashRateIncrease")
    def crash_rate_increase(self) -> Optional[pulumi.Input['MobileAppCrashRateCrashRateIncreaseArgs']]:
        """
        Crash rate increase
        """
        return pulumi.get(self, "crash_rate_increase")

    @crash_rate_increase.setter
    def crash_rate_increase(self, value: Optional[pulumi.Input['MobileAppCrashRateCrashRateIncreaseArgs']]):
        pulumi.set(self, "crash_rate_increase", value)


class MobileAppCrashRate(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 application_id: Optional[pulumi.Input[str]] = None,
                 crash_rate_increase: Optional[pulumi.Input[Union['MobileAppCrashRateCrashRateIncreaseArgs', 'MobileAppCrashRateCrashRateIncreaseArgsDict']]] = None,
                 __props__=None):
        """
        Create a MobileAppCrashRate resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] application_id: The scope of this settings. If the settings should cover the whole environment, just don't specify any scope.
        :param pulumi.Input[Union['MobileAppCrashRateCrashRateIncreaseArgs', 'MobileAppCrashRateCrashRateIncreaseArgsDict']] crash_rate_increase: Crash rate increase
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: MobileAppCrashRateArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a MobileAppCrashRate resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param MobileAppCrashRateArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(MobileAppCrashRateArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 application_id: Optional[pulumi.Input[str]] = None,
                 crash_rate_increase: Optional[pulumi.Input[Union['MobileAppCrashRateCrashRateIncreaseArgs', 'MobileAppCrashRateCrashRateIncreaseArgsDict']]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = MobileAppCrashRateArgs.__new__(MobileAppCrashRateArgs)

            __props__.__dict__["application_id"] = application_id
            if crash_rate_increase is None and not opts.urn:
                raise TypeError("Missing required property 'crash_rate_increase'")
            __props__.__dict__["crash_rate_increase"] = crash_rate_increase
        super(MobileAppCrashRate, __self__).__init__(
            'dynatrace:index/mobileAppCrashRate:MobileAppCrashRate',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            application_id: Optional[pulumi.Input[str]] = None,
            crash_rate_increase: Optional[pulumi.Input[Union['MobileAppCrashRateCrashRateIncreaseArgs', 'MobileAppCrashRateCrashRateIncreaseArgsDict']]] = None) -> 'MobileAppCrashRate':
        """
        Get an existing MobileAppCrashRate resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] application_id: The scope of this settings. If the settings should cover the whole environment, just don't specify any scope.
        :param pulumi.Input[Union['MobileAppCrashRateCrashRateIncreaseArgs', 'MobileAppCrashRateCrashRateIncreaseArgsDict']] crash_rate_increase: Crash rate increase
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _MobileAppCrashRateState.__new__(_MobileAppCrashRateState)

        __props__.__dict__["application_id"] = application_id
        __props__.__dict__["crash_rate_increase"] = crash_rate_increase
        return MobileAppCrashRate(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="applicationId")
    def application_id(self) -> pulumi.Output[Optional[str]]:
        """
        The scope of this settings. If the settings should cover the whole environment, just don't specify any scope.
        """
        return pulumi.get(self, "application_id")

    @property
    @pulumi.getter(name="crashRateIncrease")
    def crash_rate_increase(self) -> pulumi.Output['outputs.MobileAppCrashRateCrashRateIncrease']:
        """
        Crash rate increase
        """
        return pulumi.get(self, "crash_rate_increase")

