# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['OneagentDefaultModeArgs', 'OneagentDefaultMode']

@pulumi.input_type
class OneagentDefaultModeArgs:
    def __init__(__self__, *,
                 default_mode: pulumi.Input[str]):
        """
        The set of arguments for constructing a OneagentDefaultMode resource.
        :param pulumi.Input[str] default_mode: Possible Values: `DISCOVERY`, `FULL_STACK`, `INFRASTRUCTURE`
        """
        pulumi.set(__self__, "default_mode", default_mode)

    @property
    @pulumi.getter(name="defaultMode")
    def default_mode(self) -> pulumi.Input[str]:
        """
        Possible Values: `DISCOVERY`, `FULL_STACK`, `INFRASTRUCTURE`
        """
        return pulumi.get(self, "default_mode")

    @default_mode.setter
    def default_mode(self, value: pulumi.Input[str]):
        pulumi.set(self, "default_mode", value)


@pulumi.input_type
class _OneagentDefaultModeState:
    def __init__(__self__, *,
                 default_mode: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering OneagentDefaultMode resources.
        :param pulumi.Input[str] default_mode: Possible Values: `DISCOVERY`, `FULL_STACK`, `INFRASTRUCTURE`
        """
        if default_mode is not None:
            pulumi.set(__self__, "default_mode", default_mode)

    @property
    @pulumi.getter(name="defaultMode")
    def default_mode(self) -> Optional[pulumi.Input[str]]:
        """
        Possible Values: `DISCOVERY`, `FULL_STACK`, `INFRASTRUCTURE`
        """
        return pulumi.get(self, "default_mode")

    @default_mode.setter
    def default_mode(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "default_mode", value)


class OneagentDefaultMode(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 default_mode: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Create a OneagentDefaultMode resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] default_mode: Possible Values: `DISCOVERY`, `FULL_STACK`, `INFRASTRUCTURE`
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: OneagentDefaultModeArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a OneagentDefaultMode resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param OneagentDefaultModeArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(OneagentDefaultModeArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 default_mode: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = OneagentDefaultModeArgs.__new__(OneagentDefaultModeArgs)

            if default_mode is None and not opts.urn:
                raise TypeError("Missing required property 'default_mode'")
            __props__.__dict__["default_mode"] = default_mode
        super(OneagentDefaultMode, __self__).__init__(
            'dynatrace:index/oneagentDefaultMode:OneagentDefaultMode',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            default_mode: Optional[pulumi.Input[str]] = None) -> 'OneagentDefaultMode':
        """
        Get an existing OneagentDefaultMode resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] default_mode: Possible Values: `DISCOVERY`, `FULL_STACK`, `INFRASTRUCTURE`
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _OneagentDefaultModeState.__new__(_OneagentDefaultModeState)

        __props__.__dict__["default_mode"] = default_mode
        return OneagentDefaultMode(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="defaultMode")
    def default_mode(self) -> pulumi.Output[str]:
        """
        Possible Values: `DISCOVERY`, `FULL_STACK`, `INFRASTRUCTURE`
        """
        return pulumi.get(self, "default_mode")

