# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['SyntheticAvailabilityArgs', 'SyntheticAvailability']

@pulumi.input_type
class SyntheticAvailabilityArgs:
    def __init__(__self__, *,
                 exclude_maintenance_windows: pulumi.Input[bool]):
        """
        The set of arguments for constructing a SyntheticAvailability resource.
        :param pulumi.Input[bool] exclude_maintenance_windows: Exclude periods with maintenance windows from availability calculation
        """
        pulumi.set(__self__, "exclude_maintenance_windows", exclude_maintenance_windows)

    @property
    @pulumi.getter(name="excludeMaintenanceWindows")
    def exclude_maintenance_windows(self) -> pulumi.Input[bool]:
        """
        Exclude periods with maintenance windows from availability calculation
        """
        return pulumi.get(self, "exclude_maintenance_windows")

    @exclude_maintenance_windows.setter
    def exclude_maintenance_windows(self, value: pulumi.Input[bool]):
        pulumi.set(self, "exclude_maintenance_windows", value)


@pulumi.input_type
class _SyntheticAvailabilityState:
    def __init__(__self__, *,
                 exclude_maintenance_windows: Optional[pulumi.Input[bool]] = None):
        """
        Input properties used for looking up and filtering SyntheticAvailability resources.
        :param pulumi.Input[bool] exclude_maintenance_windows: Exclude periods with maintenance windows from availability calculation
        """
        if exclude_maintenance_windows is not None:
            pulumi.set(__self__, "exclude_maintenance_windows", exclude_maintenance_windows)

    @property
    @pulumi.getter(name="excludeMaintenanceWindows")
    def exclude_maintenance_windows(self) -> Optional[pulumi.Input[bool]]:
        """
        Exclude periods with maintenance windows from availability calculation
        """
        return pulumi.get(self, "exclude_maintenance_windows")

    @exclude_maintenance_windows.setter
    def exclude_maintenance_windows(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "exclude_maintenance_windows", value)


class SyntheticAvailability(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 exclude_maintenance_windows: Optional[pulumi.Input[bool]] = None,
                 __props__=None):
        """
        Create a SyntheticAvailability resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] exclude_maintenance_windows: Exclude periods with maintenance windows from availability calculation
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: SyntheticAvailabilityArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a SyntheticAvailability resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param SyntheticAvailabilityArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(SyntheticAvailabilityArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 exclude_maintenance_windows: Optional[pulumi.Input[bool]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = SyntheticAvailabilityArgs.__new__(SyntheticAvailabilityArgs)

            if exclude_maintenance_windows is None and not opts.urn:
                raise TypeError("Missing required property 'exclude_maintenance_windows'")
            __props__.__dict__["exclude_maintenance_windows"] = exclude_maintenance_windows
        super(SyntheticAvailability, __self__).__init__(
            'dynatrace:index/syntheticAvailability:SyntheticAvailability',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            exclude_maintenance_windows: Optional[pulumi.Input[bool]] = None) -> 'SyntheticAvailability':
        """
        Get an existing SyntheticAvailability resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] exclude_maintenance_windows: Exclude periods with maintenance windows from availability calculation
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _SyntheticAvailabilityState.__new__(_SyntheticAvailabilityState)

        __props__.__dict__["exclude_maintenance_windows"] = exclude_maintenance_windows
        return SyntheticAvailability(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="excludeMaintenanceWindows")
    def exclude_maintenance_windows(self) -> pulumi.Output[bool]:
        """
        Exclude periods with maintenance windows from availability calculation
        """
        return pulumi.get(self, "exclude_maintenance_windows")

