# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['EbpfServiceDiscoveryArgs', 'EbpfServiceDiscovery']

@pulumi.input_type
class EbpfServiceDiscoveryArgs:
    def __init__(__self__, *,
                 ebpf: pulumi.Input[bool],
                 scope: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a EbpfServiceDiscovery resource.
        :param pulumi.Input[bool] ebpf: When disabled, Dynatrace can only detect services in Full stack mode.
        :param pulumi.Input[str] scope: The scope of this setting (HOST, HOST_GROUP). Omit this property if you want to cover the whole environment.
        """
        pulumi.set(__self__, "ebpf", ebpf)
        if scope is not None:
            pulumi.set(__self__, "scope", scope)

    @property
    @pulumi.getter
    def ebpf(self) -> pulumi.Input[bool]:
        """
        When disabled, Dynatrace can only detect services in Full stack mode.
        """
        return pulumi.get(self, "ebpf")

    @ebpf.setter
    def ebpf(self, value: pulumi.Input[bool]):
        pulumi.set(self, "ebpf", value)

    @property
    @pulumi.getter
    def scope(self) -> Optional[pulumi.Input[str]]:
        """
        The scope of this setting (HOST, HOST_GROUP). Omit this property if you want to cover the whole environment.
        """
        return pulumi.get(self, "scope")

    @scope.setter
    def scope(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "scope", value)


@pulumi.input_type
class _EbpfServiceDiscoveryState:
    def __init__(__self__, *,
                 ebpf: Optional[pulumi.Input[bool]] = None,
                 scope: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering EbpfServiceDiscovery resources.
        :param pulumi.Input[bool] ebpf: When disabled, Dynatrace can only detect services in Full stack mode.
        :param pulumi.Input[str] scope: The scope of this setting (HOST, HOST_GROUP). Omit this property if you want to cover the whole environment.
        """
        if ebpf is not None:
            pulumi.set(__self__, "ebpf", ebpf)
        if scope is not None:
            pulumi.set(__self__, "scope", scope)

    @property
    @pulumi.getter
    def ebpf(self) -> Optional[pulumi.Input[bool]]:
        """
        When disabled, Dynatrace can only detect services in Full stack mode.
        """
        return pulumi.get(self, "ebpf")

    @ebpf.setter
    def ebpf(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "ebpf", value)

    @property
    @pulumi.getter
    def scope(self) -> Optional[pulumi.Input[str]]:
        """
        The scope of this setting (HOST, HOST_GROUP). Omit this property if you want to cover the whole environment.
        """
        return pulumi.get(self, "scope")

    @scope.setter
    def scope(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "scope", value)


class EbpfServiceDiscovery(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 ebpf: Optional[pulumi.Input[bool]] = None,
                 scope: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Create a EbpfServiceDiscovery resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] ebpf: When disabled, Dynatrace can only detect services in Full stack mode.
        :param pulumi.Input[str] scope: The scope of this setting (HOST, HOST_GROUP). Omit this property if you want to cover the whole environment.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: EbpfServiceDiscoveryArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a EbpfServiceDiscovery resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param EbpfServiceDiscoveryArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(EbpfServiceDiscoveryArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 ebpf: Optional[pulumi.Input[bool]] = None,
                 scope: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = EbpfServiceDiscoveryArgs.__new__(EbpfServiceDiscoveryArgs)

            if ebpf is None and not opts.urn:
                raise TypeError("Missing required property 'ebpf'")
            __props__.__dict__["ebpf"] = ebpf
            __props__.__dict__["scope"] = scope
        super(EbpfServiceDiscovery, __self__).__init__(
            'dynatrace:index/ebpfServiceDiscovery:EbpfServiceDiscovery',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            ebpf: Optional[pulumi.Input[bool]] = None,
            scope: Optional[pulumi.Input[str]] = None) -> 'EbpfServiceDiscovery':
        """
        Get an existing EbpfServiceDiscovery resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] ebpf: When disabled, Dynatrace can only detect services in Full stack mode.
        :param pulumi.Input[str] scope: The scope of this setting (HOST, HOST_GROUP). Omit this property if you want to cover the whole environment.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _EbpfServiceDiscoveryState.__new__(_EbpfServiceDiscoveryState)

        __props__.__dict__["ebpf"] = ebpf
        __props__.__dict__["scope"] = scope
        return EbpfServiceDiscovery(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def ebpf(self) -> pulumi.Output[bool]:
        """
        When disabled, Dynatrace can only detect services in Full stack mode.
        """
        return pulumi.get(self, "ebpf")

    @property
    @pulumi.getter
    def scope(self) -> pulumi.Output[Optional[str]]:
        """
        The scope of this setting (HOST, HOST_GROUP). Omit this property if you want to cover the whole environment.
        """
        return pulumi.get(self, "scope")

