# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['MonitoredTechnologiesDotnetArgs', 'MonitoredTechnologiesDotnet']

@pulumi.input_type
class MonitoredTechnologiesDotnetArgs:
    def __init__(__self__, *,
                 enabled: pulumi.Input[bool],
                 enabled_dot_net_core: Optional[pulumi.Input[bool]] = None,
                 host_id: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a MonitoredTechnologiesDotnet resource.
        :param pulumi.Input[bool] enabled: This setting is enabled (`true`) or disabled (`false`)
        :param pulumi.Input[bool] enabled_dot_net_core: Requires Dynatrace OneAgent version 1.117 or later on Windows and version 1.127 or later on Linux and .NET monitoring enabled
        :param pulumi.Input[str] host_id: The scope of this settings. If the settings should cover the whole environment, just don't specify any scope.
        """
        pulumi.set(__self__, "enabled", enabled)
        if enabled_dot_net_core is not None:
            pulumi.set(__self__, "enabled_dot_net_core", enabled_dot_net_core)
        if host_id is not None:
            pulumi.set(__self__, "host_id", host_id)

    @property
    @pulumi.getter
    def enabled(self) -> pulumi.Input[bool]:
        """
        This setting is enabled (`true`) or disabled (`false`)
        """
        return pulumi.get(self, "enabled")

    @enabled.setter
    def enabled(self, value: pulumi.Input[bool]):
        pulumi.set(self, "enabled", value)

    @property
    @pulumi.getter(name="enabledDotNetCore")
    def enabled_dot_net_core(self) -> Optional[pulumi.Input[bool]]:
        """
        Requires Dynatrace OneAgent version 1.117 or later on Windows and version 1.127 or later on Linux and .NET monitoring enabled
        """
        return pulumi.get(self, "enabled_dot_net_core")

    @enabled_dot_net_core.setter
    def enabled_dot_net_core(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enabled_dot_net_core", value)

    @property
    @pulumi.getter(name="hostId")
    def host_id(self) -> Optional[pulumi.Input[str]]:
        """
        The scope of this settings. If the settings should cover the whole environment, just don't specify any scope.
        """
        return pulumi.get(self, "host_id")

    @host_id.setter
    def host_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "host_id", value)


@pulumi.input_type
class _MonitoredTechnologiesDotnetState:
    def __init__(__self__, *,
                 enabled: Optional[pulumi.Input[bool]] = None,
                 enabled_dot_net_core: Optional[pulumi.Input[bool]] = None,
                 host_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering MonitoredTechnologiesDotnet resources.
        :param pulumi.Input[bool] enabled: This setting is enabled (`true`) or disabled (`false`)
        :param pulumi.Input[bool] enabled_dot_net_core: Requires Dynatrace OneAgent version 1.117 or later on Windows and version 1.127 or later on Linux and .NET monitoring enabled
        :param pulumi.Input[str] host_id: The scope of this settings. If the settings should cover the whole environment, just don't specify any scope.
        """
        if enabled is not None:
            pulumi.set(__self__, "enabled", enabled)
        if enabled_dot_net_core is not None:
            pulumi.set(__self__, "enabled_dot_net_core", enabled_dot_net_core)
        if host_id is not None:
            pulumi.set(__self__, "host_id", host_id)

    @property
    @pulumi.getter
    def enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        This setting is enabled (`true`) or disabled (`false`)
        """
        return pulumi.get(self, "enabled")

    @enabled.setter
    def enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enabled", value)

    @property
    @pulumi.getter(name="enabledDotNetCore")
    def enabled_dot_net_core(self) -> Optional[pulumi.Input[bool]]:
        """
        Requires Dynatrace OneAgent version 1.117 or later on Windows and version 1.127 or later on Linux and .NET monitoring enabled
        """
        return pulumi.get(self, "enabled_dot_net_core")

    @enabled_dot_net_core.setter
    def enabled_dot_net_core(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enabled_dot_net_core", value)

    @property
    @pulumi.getter(name="hostId")
    def host_id(self) -> Optional[pulumi.Input[str]]:
        """
        The scope of this settings. If the settings should cover the whole environment, just don't specify any scope.
        """
        return pulumi.get(self, "host_id")

    @host_id.setter
    def host_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "host_id", value)


class MonitoredTechnologiesDotnet(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 enabled: Optional[pulumi.Input[bool]] = None,
                 enabled_dot_net_core: Optional[pulumi.Input[bool]] = None,
                 host_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Create a MonitoredTechnologiesDotnet resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] enabled: This setting is enabled (`true`) or disabled (`false`)
        :param pulumi.Input[bool] enabled_dot_net_core: Requires Dynatrace OneAgent version 1.117 or later on Windows and version 1.127 or later on Linux and .NET monitoring enabled
        :param pulumi.Input[str] host_id: The scope of this settings. If the settings should cover the whole environment, just don't specify any scope.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: MonitoredTechnologiesDotnetArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a MonitoredTechnologiesDotnet resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param MonitoredTechnologiesDotnetArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(MonitoredTechnologiesDotnetArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 enabled: Optional[pulumi.Input[bool]] = None,
                 enabled_dot_net_core: Optional[pulumi.Input[bool]] = None,
                 host_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = MonitoredTechnologiesDotnetArgs.__new__(MonitoredTechnologiesDotnetArgs)

            if enabled is None and not opts.urn:
                raise TypeError("Missing required property 'enabled'")
            __props__.__dict__["enabled"] = enabled
            __props__.__dict__["enabled_dot_net_core"] = enabled_dot_net_core
            __props__.__dict__["host_id"] = host_id
        super(MonitoredTechnologiesDotnet, __self__).__init__(
            'dynatrace:index/monitoredTechnologiesDotnet:MonitoredTechnologiesDotnet',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            enabled: Optional[pulumi.Input[bool]] = None,
            enabled_dot_net_core: Optional[pulumi.Input[bool]] = None,
            host_id: Optional[pulumi.Input[str]] = None) -> 'MonitoredTechnologiesDotnet':
        """
        Get an existing MonitoredTechnologiesDotnet resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] enabled: This setting is enabled (`true`) or disabled (`false`)
        :param pulumi.Input[bool] enabled_dot_net_core: Requires Dynatrace OneAgent version 1.117 or later on Windows and version 1.127 or later on Linux and .NET monitoring enabled
        :param pulumi.Input[str] host_id: The scope of this settings. If the settings should cover the whole environment, just don't specify any scope.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _MonitoredTechnologiesDotnetState.__new__(_MonitoredTechnologiesDotnetState)

        __props__.__dict__["enabled"] = enabled
        __props__.__dict__["enabled_dot_net_core"] = enabled_dot_net_core
        __props__.__dict__["host_id"] = host_id
        return MonitoredTechnologiesDotnet(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def enabled(self) -> pulumi.Output[bool]:
        """
        This setting is enabled (`true`) or disabled (`false`)
        """
        return pulumi.get(self, "enabled")

    @property
    @pulumi.getter(name="enabledDotNetCore")
    def enabled_dot_net_core(self) -> pulumi.Output[Optional[bool]]:
        """
        Requires Dynatrace OneAgent version 1.117 or later on Windows and version 1.127 or later on Linux and .NET monitoring enabled
        """
        return pulumi.get(self, "enabled_dot_net_core")

    @property
    @pulumi.getter(name="hostId")
    def host_id(self) -> pulumi.Output[Optional[str]]:
        """
        The scope of this settings. If the settings should cover the whole environment, just don't specify any scope.
        """
        return pulumi.get(self, "host_id")

