# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['ResourceAttributesArgs', 'ResourceAttributes']

@pulumi.input_type
class ResourceAttributesArgs:
    def __init__(__self__, *,
                 keys: Optional[pulumi.Input['ResourceAttributesKeysArgs']] = None):
        """
        The set of arguments for constructing a ResourceAttributes resource.
        :param pulumi.Input['ResourceAttributesKeysArgs'] keys: Attribute key allow-list
        """
        if keys is not None:
            pulumi.set(__self__, "keys", keys)

    @property
    @pulumi.getter
    def keys(self) -> Optional[pulumi.Input['ResourceAttributesKeysArgs']]:
        """
        Attribute key allow-list
        """
        return pulumi.get(self, "keys")

    @keys.setter
    def keys(self, value: Optional[pulumi.Input['ResourceAttributesKeysArgs']]):
        pulumi.set(self, "keys", value)


@pulumi.input_type
class _ResourceAttributesState:
    def __init__(__self__, *,
                 keys: Optional[pulumi.Input['ResourceAttributesKeysArgs']] = None):
        """
        Input properties used for looking up and filtering ResourceAttributes resources.
        :param pulumi.Input['ResourceAttributesKeysArgs'] keys: Attribute key allow-list
        """
        if keys is not None:
            pulumi.set(__self__, "keys", keys)

    @property
    @pulumi.getter
    def keys(self) -> Optional[pulumi.Input['ResourceAttributesKeysArgs']]:
        """
        Attribute key allow-list
        """
        return pulumi.get(self, "keys")

    @keys.setter
    def keys(self, value: Optional[pulumi.Input['ResourceAttributesKeysArgs']]):
        pulumi.set(self, "keys", value)


class ResourceAttributes(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 keys: Optional[pulumi.Input[pulumi.InputType['ResourceAttributesKeysArgs']]] = None,
                 __props__=None):
        """
        Create a ResourceAttributes resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[pulumi.InputType['ResourceAttributesKeysArgs']] keys: Attribute key allow-list
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[ResourceAttributesArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a ResourceAttributes resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param ResourceAttributesArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ResourceAttributesArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 keys: Optional[pulumi.Input[pulumi.InputType['ResourceAttributesKeysArgs']]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ResourceAttributesArgs.__new__(ResourceAttributesArgs)

            __props__.__dict__["keys"] = keys
        super(ResourceAttributes, __self__).__init__(
            'dynatrace:index/resourceAttributes:ResourceAttributes',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            keys: Optional[pulumi.Input[pulumi.InputType['ResourceAttributesKeysArgs']]] = None) -> 'ResourceAttributes':
        """
        Get an existing ResourceAttributes resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[pulumi.InputType['ResourceAttributesKeysArgs']] keys: Attribute key allow-list
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ResourceAttributesState.__new__(_ResourceAttributesState)

        __props__.__dict__["keys"] = keys
        return ResourceAttributes(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def keys(self) -> pulumi.Output[Optional['outputs.ResourceAttributesKeys']]:
        """
        Attribute key allow-list
        """
        return pulumi.get(self, "keys")

