# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['WebAppKeyPerformanceCustomArgs', 'WebAppKeyPerformanceCustom']

@pulumi.input_type
class WebAppKeyPerformanceCustomArgs:
    def __init__(__self__, *,
                 scope: pulumi.Input[str],
                 thresholds: pulumi.Input['WebAppKeyPerformanceCustomThresholdsArgs']):
        """
        The set of arguments for constructing a WebAppKeyPerformanceCustom resource.
        :param pulumi.Input[str] scope: The scope of this setting (APPLICATION_METHOD, APPLICATION)
        :param pulumi.Input['WebAppKeyPerformanceCustomThresholdsArgs'] thresholds: User action duration thresholds
        """
        pulumi.set(__self__, "scope", scope)
        pulumi.set(__self__, "thresholds", thresholds)

    @property
    @pulumi.getter
    def scope(self) -> pulumi.Input[str]:
        """
        The scope of this setting (APPLICATION_METHOD, APPLICATION)
        """
        return pulumi.get(self, "scope")

    @scope.setter
    def scope(self, value: pulumi.Input[str]):
        pulumi.set(self, "scope", value)

    @property
    @pulumi.getter
    def thresholds(self) -> pulumi.Input['WebAppKeyPerformanceCustomThresholdsArgs']:
        """
        User action duration thresholds
        """
        return pulumi.get(self, "thresholds")

    @thresholds.setter
    def thresholds(self, value: pulumi.Input['WebAppKeyPerformanceCustomThresholdsArgs']):
        pulumi.set(self, "thresholds", value)


@pulumi.input_type
class _WebAppKeyPerformanceCustomState:
    def __init__(__self__, *,
                 scope: Optional[pulumi.Input[str]] = None,
                 thresholds: Optional[pulumi.Input['WebAppKeyPerformanceCustomThresholdsArgs']] = None):
        """
        Input properties used for looking up and filtering WebAppKeyPerformanceCustom resources.
        :param pulumi.Input[str] scope: The scope of this setting (APPLICATION_METHOD, APPLICATION)
        :param pulumi.Input['WebAppKeyPerformanceCustomThresholdsArgs'] thresholds: User action duration thresholds
        """
        if scope is not None:
            pulumi.set(__self__, "scope", scope)
        if thresholds is not None:
            pulumi.set(__self__, "thresholds", thresholds)

    @property
    @pulumi.getter
    def scope(self) -> Optional[pulumi.Input[str]]:
        """
        The scope of this setting (APPLICATION_METHOD, APPLICATION)
        """
        return pulumi.get(self, "scope")

    @scope.setter
    def scope(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "scope", value)

    @property
    @pulumi.getter
    def thresholds(self) -> Optional[pulumi.Input['WebAppKeyPerformanceCustomThresholdsArgs']]:
        """
        User action duration thresholds
        """
        return pulumi.get(self, "thresholds")

    @thresholds.setter
    def thresholds(self, value: Optional[pulumi.Input['WebAppKeyPerformanceCustomThresholdsArgs']]):
        pulumi.set(self, "thresholds", value)


class WebAppKeyPerformanceCustom(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 scope: Optional[pulumi.Input[str]] = None,
                 thresholds: Optional[pulumi.Input[pulumi.InputType['WebAppKeyPerformanceCustomThresholdsArgs']]] = None,
                 __props__=None):
        """
        Create a WebAppKeyPerformanceCustom resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] scope: The scope of this setting (APPLICATION_METHOD, APPLICATION)
        :param pulumi.Input[pulumi.InputType['WebAppKeyPerformanceCustomThresholdsArgs']] thresholds: User action duration thresholds
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: WebAppKeyPerformanceCustomArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a WebAppKeyPerformanceCustom resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param WebAppKeyPerformanceCustomArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(WebAppKeyPerformanceCustomArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 scope: Optional[pulumi.Input[str]] = None,
                 thresholds: Optional[pulumi.Input[pulumi.InputType['WebAppKeyPerformanceCustomThresholdsArgs']]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = WebAppKeyPerformanceCustomArgs.__new__(WebAppKeyPerformanceCustomArgs)

            if scope is None and not opts.urn:
                raise TypeError("Missing required property 'scope'")
            __props__.__dict__["scope"] = scope
            if thresholds is None and not opts.urn:
                raise TypeError("Missing required property 'thresholds'")
            __props__.__dict__["thresholds"] = thresholds
        super(WebAppKeyPerformanceCustom, __self__).__init__(
            'dynatrace:index/webAppKeyPerformanceCustom:WebAppKeyPerformanceCustom',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            scope: Optional[pulumi.Input[str]] = None,
            thresholds: Optional[pulumi.Input[pulumi.InputType['WebAppKeyPerformanceCustomThresholdsArgs']]] = None) -> 'WebAppKeyPerformanceCustom':
        """
        Get an existing WebAppKeyPerformanceCustom resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] scope: The scope of this setting (APPLICATION_METHOD, APPLICATION)
        :param pulumi.Input[pulumi.InputType['WebAppKeyPerformanceCustomThresholdsArgs']] thresholds: User action duration thresholds
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _WebAppKeyPerformanceCustomState.__new__(_WebAppKeyPerformanceCustomState)

        __props__.__dict__["scope"] = scope
        __props__.__dict__["thresholds"] = thresholds
        return WebAppKeyPerformanceCustom(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def scope(self) -> pulumi.Output[str]:
        """
        The scope of this setting (APPLICATION_METHOD, APPLICATION)
        """
        return pulumi.get(self, "scope")

    @property
    @pulumi.getter
    def thresholds(self) -> pulumi.Output['outputs.WebAppKeyPerformanceCustomThresholds']:
        """
        User action duration thresholds
        """
        return pulumi.get(self, "thresholds")

